unit Unit3;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, IdComponent, IdTCPConnection, IdTCPClient, IdFTP,
  IdBaseComponent, IdAntiFreezeBase, IdAntiFreeze, QComCtrls;

type
  TForm3 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    Button2: TButton;
    Button3: TButton;
    ProgressBar1: TProgressBar;
    IdAntiFreeze1: TIdAntiFreeze;
    NMFTP1: TIdFTP;
    ListBox1: TListBox;
    Memo1: TMemo;
    Button4: TButton;
    EEMAILadr: TEdit;
    Label3: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure NMFTP1Disconnected(Sender: TObject);
    procedure EnableControls(Enable: boolean);
    procedure NMFTP1Status(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: String);
    procedure Button3Click(Sender: TObject);
    procedure GetServeurType(const ServeurEntry : string);
    procedure FormShow(Sender: TObject);

  private
    { Dclarations prives }
  public
    MPC_fichier : string;
    { Dclarations publiques }
  end;

var
  Form3: TForm3;

implementation

{$R *.xfm}


type
   TFTPServeurType = (ftpUnix,ftpWin);
var
   FTPServeurType : TFTPServeurType;

function AccessAllowed(const Entry : string) : boolean;
begin
   IF FTPServeurType=ftpWin then result:=true
   else
      result:=(Length(Trim(Entry))>7) and (Lowercase(Trim(Entry))[8]='r')
end;

function IsDir(const entry : string) : boolean;
begin
   IF FTPServeurType=ftpWin then result:=true
   else
      result:=(Length(Trim(Entry))>0) and (Lowercase(Trim(Entry))[8]='d')
end;

function IsFATDir(const FatEntry : string) : boolean;
var
   s : string;
begin
   s:=Trim(FATEntry);
   s:=Trim(copy(s,pos(' ',s)+1,length(s)));
   s:=Trim(copy(s,pos(' ',s)+1,Length(s)));
   s:=Trim(copy(s,1,pos(' ',s)-1));
   Result:=Uppercase(s)='<DIR>';
end;

procedure TForm3.GetServeurType(const ServeurEntry : string);
var
   s : string;
begin
   s:=Trim(ServeurEntry);
   s:=Trim(copy(s,pos(' ',s)+1,length(s)));
   s:=Trim(copy(s,pos(' ',s)+1,Length(s)));
   s:=Trim(copy(s,pos(' ',s)+1,Length(s)));
   FTPServeurType:=TFTPServeurType(Pos(' ',s)=0);
end;

procedure TForm3.EnableControls(Enable: boolean);
begin
  Button2.Enabled := Enable;
  Button3.Enabled := Enable and NMFTP1.Connected;
  {SpeedButton1.Enabled := Enable and IdFTP1.Connected;}
  ListBox1.Enabled := Enable and NMFTP1.Connected;
end;


procedure TForm3.Button2Click(Sender: TObject);
begin
   if NMFTP1.Connected then NMFTP1.Disconnect;
   try
      NMFTP1.Host:='cfa-ftp.harvard.edu';
      NMFTP1.Username:='anonymous';
      NMFTP1.Password:=EEMAILadr.Text;
      NMFTP1.connect(true);
      NMFTP1.Get('pub/MPCORB/'+MPC_fichier,MPC_Fichier,true);  {  vrifier }

      { ftp://anonymous:prism%40astrosurf.com@cfa-ftp.harvard.edu/pub/MPCORB/ }

{ L'URL est ftp://ftp.lowell.edu/pub/elgb/astorb.dat.gz }

{ Autre exemple qui fonctionne :
      NMFTP1.Host:='ftp.ncsa.uiuc.edu';
      NMFTP1.Username:='anonymous';
      NMFTP1.Password:='marc.serrau@free.fr';
      NMFTP1.connect(true);
      NMFTP1.Get('Web/Mosaic/Unix/README.Mosaic','README.mosaic',true);
}
   if NMFTP1.Connected then
   try
      NMFTP1.List(ListBox1.Items);
   except;
   end;
   finally
      EnableControls(true);

   end;
end;

procedure TForm3.Button1Click(Sender: TObject);
begin
   Form3.Hide;
end;

procedure TForm3.NMFTP1Disconnected(Sender: TObject);
begin
  ListBox1.Clear;
  EnableControls(true);
end;

procedure TForm3.NMFTP1Status(ASender: TObject; const AStatus: TIdStatus;
  const AStatusText: String);
begin
   Memo1.Lines.Add(aStatusText);
end;

procedure TForm3.Button3Click(Sender: TObject);
begin
   if NMFTP1.Connected then NMFTP1.Disconnect;
end;

procedure TForm3.FormShow(Sender: TObject);
begin
   Memo1.Lines.Append(MPC_Fichier+'  tlcharger.');
end;

end.
