{
   Librairie TEMPS.PAS

   Mis au standard Maxon Pascal 1.5              le 12/03/1992
   Radaptation pour Borland Pascal 7            le 25/02/1996
   Ajout de la procedure JJ2Greg                 le 16/06/1998
   Li  temps.pas pour utilisation avec Kylix 3 le 11/10/2004
}
unit temps;

interface

type
   T_Date = record
      Jour,Mois,Annee : word;
      heure           : real;
   end;
function nombre(d : T_Date):real;
function JJ(Date : T_Date):real;
procedure Demande_Date(var date : T_Date);
procedure JJ2Greg(JD : real; var DM,M,AN : real);
function Temps_Sideral_Greenwich_0h(JJdate : real):double;
function Temps_Sideral_Local(JJDate,Longitude : real):double;

implementation

uses
   astromath;
function nombre(d : T_Date):real;
begin
   with D do
   begin
      if mois-2<0 then
      begin
         Annee:=Annee-1;
         Mois:=Mois+10;
      end
      else Mois:=Mois-2;
      Nombre:=Jour+trunc(365.25*Annee)+trunc(30.6001*(Mois+3));
   end;
end;
{
function JJ(Date : T_Date):real;
(*
   d'apres Astronomie Pratique et informatique p 221
   Il s'agit de la date julien sans tenir compte de la reforme
   gregorienne

*)
var
   N : real;
begin
   with Date do
      N:=367.0*Annee-trunc(7.0/4.0*(trunc((Mois+9)/12.0)+Annee))-trunc(3.0/4.0*
         (1+trunc((trunc((Mois-9)/7.0)+Annee)*0.01)))+
          trunc(275.0*Mois/9.0)+jour;
   JJ:=N+1721028.5;
end;
}
function JJ(Date : T_Date):real;
(* d'aprs Astronomie Pratique et Informatique p 53 *)
var
   y,m,A,JD : real;
begin
   with Date do
   begin
      y:=Annee; m:=mois;
      if Mois<3 then begin y:=y-1; m:=m+12 end;
      JD:=1720994.5+Jour+trunc(365.25*y)+trunc(30.6001*(m+1));
      { Le rsultat ci-dessus est valable avant le 4/10/1582 }
      { Correction grgorienne : }
      A:=trunc(y/100);
      JJ:=JD;
      if annee+mois/100+jour/10000>1582.1014 then
         JJ:=JD+2-A+trunc(A/4);
   end;
end;

procedure Demande_Date(var date : T_Date);
begin
   with Date do
   begin
      write('Jour  : '); readln(jour);
      write('Mois  : '); readln(mois);
      write('Annee : '); readln(annee);
   end;
end;

procedure JJ2Greg(JD : real; var DM,M,AN : real);
var
   Z,F,AL,AA,B,C,D,E,J1 : real;
begin
   J1:=JD+0.5;
   Z:=int(J1);
   F:=J1-Z;
   if Z<2299161 then AA:=Z else
   begin
      AL:=int((Z-1867216.25)/36524.25);
      AA:=Z+1+AL-int(AL/4);
   end;
   B:=AA+1524;
   C:=int((B-122.1)/365.25);
   D:=int(365.25*C);
   E:=int((B-D)/30.6001);
   DM:=B-D-int(30.6001*E)+F;

   if E<13.5 then M:=E-1;
   if E>13.5 then M:=E-13;
   if M>2.5 then AN:=C-4716;
   if M<2.5 then AN:=C-4715;

end;

function Temps_Sideral_Greenwich_0h(JJdate : real):double;
{ Renvoie le Temps sidral Moyen de Greenwich  0hTU pour le JJ considr
  Le rsultat est en RADIANS.
  cf Astron. Pratique et Informatique pp 35 }
var
   t,TSG0 : double;
begin
//   T:=(Trunc(JJdate)+0.5-2415020.0)/36525.0;
   T:=(Trunc(JJdate-0.5)-2451545.0)/36525.0;   {le Trunc JJDate-0.5 est introduit car le calcul se fait  0h TU de la date}
   TSG0:=6.697374558+8640184.812866/3600*T+0.093104/3600*T*T-6.21E-5/3600*T*T*T;
   Temps_Sideral_Greenwich_0h:=Modulo(TSG0,24)/12*Pi;
end;

function Temps_Sideral_Local(JJDate,Longitude : real):double;
{ Renvoie le temps sidral local  t TU. t est inclus dans JJDate (donc en heures dcimales).
  cf Astron. Pratique et Informatique pp 35
  La longitude est fournie en degr dcimaux
  Le temps sidral renvoy est en RADIANS.
}

var
   TSL: double;
begin
   TSL:=Temps_Sideral_Greenwich_0h(JJDate)+2*Pi*Frac(JJDate+0.5)*1.002737909+Longitude/180*Pi;
   TSL:=Modulo(TSL,2*Pi);
   Temps_Sideral_Local:=TSL;
end;

begin
end.